import unittest
import io
import contextlib
from unittest.mock import patch

from tmc import points

from tmc.utils import load, get_stdout
main = load('src.main', 'main')


@points('2.2')
class MainTest(unittest.TestCase):

    def test_00_something_is_printed(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        if not printed:
            self.fail('Et tulostanut mitään!')

    def test_01_prints_all_to_different_lines(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        lines = printed.split('\n')
        self.assertTrue(len(lines)>1,msg='Et tulostanut kaikkia tuloksia omalle rivilleen.')


    def test_02_prints_euler(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[0].strip()
        a = float(line)
        import numpy as np
        self.assertTrue(np.isclose(a,np.e,1e-8), msg='Tulostit Eulerin luvun arvon väärin.')

    def test_03_prints_correct_natural_log(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[1].strip()
        import numpy as np
        self.assertEqual(line, str(np.log(np.e)), msg='Luonnollisen logaritmin arvo ei ollut oikein.')

    def test_04_prints_correct_10_logarithm(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[2].strip()
        import numpy as np
        a = float(line)
        self.assertTrue(np.isclose(a,np.log10(np.e),rtol=1e-8), msg='Tulostit Eulerin luvun arvon väärin.')

    def test_05_prints_correct_2_logarithm(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[3].strip()
        import numpy as np
        a = float(line)
        self.assertTrue(np.isclose(a,np.log2(np.e),rtol=1e-8), msg='2-kantaisen logaritmin arvo ei ollut oikein.')

    def test_06_prints_correct_x(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[4].strip()
        import numpy as np
        self.assertEqual(line, str(2),msg='Et tulostanut lukua 2.')

    def test_07_prints_correct_exp(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[5].strip()
        import numpy as np
        a = float(line)
        self.assertTrue(np.isclose(a,np.exp(2),rtol=1e-8), msg='Tulostamasi arvo luvulle e^2 ei ollut oikein.')

    def test_08_prints_correct_exp4x(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[6].strip()
        import numpy as np
        a = float(line)
        self.assertTrue(np.isclose(a,np.exp(8),rtol=1e-8), msg='Tulostamasi arvo luvulle e^(4*2) ei ollut oikein.')

